' *****************************************************************
' *                                                               *
' *       Copyright (c) Fast Corporation, 2007                    *
' *                                                               *
' *   All Rights Reserved.  Unpublished rights  reserved  under   *
' *   the copyright laws of the Japan.                            *
' *                                                               *
' *   The software contained on this media  is  proprietary  to   *
' *   and  embodies  the  confidential  technology  of  Fast      *
' *   Corporation.  Possession, use,  duplication  or             *
' *   dissemination of the software and media is authorized only  *
' *   pursuant to a valid written license from Fast Corporation.  *
' *                                                               *
' *****************************************************************

' -----------------------------------------------------------------
' FVX Sample Program
' }XNݒ_CAO
'
' 쐬 : D.Yamaguchi
'
'  : 2007/02/16 
' -----------------------------------------------------------------

Imports System.Windows.Forms.DialogResult
Imports System.IO
Imports FVDATASLib
Imports Microsoft
Imports FVXCOMDISPLAYEXLib.DISPLAYEX_ROI_FIGURE_TYPE

Public Class frmPattern

    'FvxDisplayExI[o[CɃp^̃}XNyѕs̈\
    '}XN̓I[o[CNo.1ɕ`
    's̈̓I[o[CNo.2ɕ`
    'I[o[CNo.0́Ay[h̉~Ɏgp

    Const PI = 3.1415926

    Const TAB_FIGURE_MODE = 0   '}`[h
    Const TAB_PEN_MODE = 1      'y[h

    Const COLOR_RED = &HFF
    Const COLOR_GREEN = &HFF00

    Const PEN_MODE_CIRCLE = 0
    Const PEN_MODE_RECT = 0

    Const ALPHA_VALUE = 0.3

    'ʕi
    Dim m_intTabMode As Integer
    Dim m_intWriteBit As Integer
    Dim m_intWriteOvrNo As Integer
    Dim m_enmWriteColor As ConsoleColor

    '}`[hŎgpϐ
    Dim m_intMaskID As Integer
    Dim m_intEsseID As Integer
    Dim m_intWriteScope As Integer
    Dim m_intWriteErase As Integer

    Dim m_intRoiPoint As Integer
    Dim m_intRoiLineSegment As Integer
    Dim m_intRoiLine As Integer
    Dim m_intRoiCircle As Integer
    Dim m_intRoiRectangle As Integer
    Dim m_intRoiEllipse As Integer
    Dim m_intRoiDispFigure As Integer

    'y[hŎgpϐ
    Dim m_intPenSize As Integer
    Dim m_intPenCircleID As Integer
    Dim m_pCircle As New FvCircle
    Dim m_intWriteErase2 As Integer

    Private Sub frmPattern_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load

        'ϐ
        m_intTabMode = 0

        'FvxDisplayEx̏
        AxFvxDisplayEx1.CreateDisplay()

        'FvxDisplayEx I[o[CEnableݒ
        AxFvxDisplayEx1.SetOverlayEnable(1, True)
        AxFvxDisplayEx1.SetOverlayEnable(2, False)

        'FvxDisplayEx ROI@\
        AxFvxDisplayEx1.RoiCreateFigureWithMouse = False
        AxFvxDisplayEx1.RoiErasable = False

        'ROIl
        Dim pPoint As New FvPoint
        pPoint.x = 50
        pPoint.y = 50
        m_intRoiPoint = AxFvxDisplayEx1.RoiCreateFigure(pPoint)
        m_intRoiDispFigure = m_intRoiPoint

        Dim pLs As New FvLineSegment
        pLs.xs = 20
        pLs.ys = 20
        pLs.xe = 100
        pLs.ye = 100
        m_intRoiLineSegment = AxFvxDisplayEx1.RoiCreateFigure(pLs)
        AxFvxDisplayEx1.RoiSetFigureEnable(m_intRoiLineSegment, False)

        Dim pLine As New FvLine
        pLine.a = -1
        pLine.b = 1
        pLine.c = 20
        m_intRoiLine = AxFvxDisplayEx1.RoiCreateFigure(pLine)
        AxFvxDisplayEx1.RoiSetFigureEnable(m_intRoiLine, False)

        Dim pCircle As New FvCircle
        pCircle.x = 30
        pCircle.y = 30
        pCircle.radius = 20
        m_intRoiCircle = AxFvxDisplayEx1.RoiCreateFigure(pCircle)
        AxFvxDisplayEx1.RoiSetFigureEnable(m_intRoiCircle, False)

        Dim pRect As New FvRectangle
        pRect.xs = 20
        pRect.ys = 20
        pRect.xe = 100
        pRect.ye = 100
        m_intRoiRectangle = AxFvxDisplayEx1.RoiCreateFigureEx(pRect, 1, True)
        AxFvxDisplayEx1.RoiSetFigureEnable(m_intRoiRectangle, False)

        pRect.xs = 20
        pRect.ys = 20
        pRect.xe = 100
        pRect.ye = 100
        m_intRoiEllipse = AxFvxDisplayEx1.RoiCreateFigureEx(pRect, 1, True)

        AxFvxDisplayEx1.RoiSetFigureEnable(m_intRoiEllipse, False)

        'ROI[hɕύX
        AxFvxDisplayEx1.RoiChangeActiveFigure(m_intRoiPoint)
        AxFvxDisplayEx1.RoiMode = FVXCOMDISPLAYEXLib.DISPLAYEX_ROI_MODE.DISPLAYEX_ROIEnable

        'y[h̐}`𐶐
        pCircle.x = -10
        pCircle.y = -10
        pCircle.radius = 1
        m_intPenCircleID = AxFvxDisplayEx1.DrawData(0, pCircle)

        AxFvxDisplayEx1.SetFigureEnable(m_intPenCircleID, True)

        'IvV̏
        m_intWriteBit = &H1
        m_intWriteOvrNo = 1
        m_enmWriteColor = COLOR_RED
        m_intWriteScope = 1
        m_intWriteErase = 0

        AxFvxDisplayEx1.DrawImage(frmMain.AxFvxPattern1.GetOcx())

    End Sub

    'EBhETCYύXꂽƂ̏
    Private Sub frmPattern_Resize(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Resize

        If Me.WindowState = 0 Or Me.WindowState = 2 Then
            Dim newSize As New Size
            newSize.Width = Me.Width - AxFvxDisplayEx1.Left - 20
            newSize.Height = Me.Height - AxFvxDisplayEx1.Top - 55
            AxFvxDisplayEx1.Size = newSize
        End If

    End Sub

    'Write/Erase2̃NbN
    Private Sub rbtWriteErase2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rbtWriteErase2_1.Click, rbtWriteErase2_0.Click

        Dim strTemp As String

        strTemp = VisualBasic.Right(sender.name, 1)
        m_intWriteErase2 = Integer.Parse(strTemp)

    End Sub

    'yTCYgbNo[̕ύX
    Private Sub trbPenSize_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles trbPenSize.Scroll

        txtPenSize.Text = trbPenSize.Value.ToString()

    End Sub

    '摜\{XN[(}`[h/y[h)
    Private Sub trbScale_Scroll(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles trbScale.Scroll

        gbxScale.Text = "\XP[<" + trbScale.Value.ToString() + "%>"
        AxFvxDisplayEx1.Magnification = trbScale.Value / 100.0#

    End Sub

    'FvxDisplayEx̃}EX_uNbN
    Private Sub AxFvxDisplayEx1_MouseDblClick(ByVal sender As System.Object, ByVal e As AxFVXCOMDISPLAYEXLib._IFvxDisplayExEvents_MouseDblClickEvent) Handles AxFvxDisplayEx1.MouseDblClick

        If TAB_FIGURE_MODE = m_intTabMode Then
            '}`[h
            fnFigMode_DblClick(e.button, e.shift, e.x, e.y, e.inOut)
        Else
            'y[h̏ꍇ͉NȂ
        End If

    End Sub

    'FvxDisplayEx̃}EX[u
    Private Sub AxFvxDisplayEx1_MouseMoveEvent(ByVal sender As System.Object, ByVal e As AxFVXCOMDISPLAYEXLib._IFvxDisplayExEvents_MouseMoveEvent) Handles AxFvxDisplayEx1.MouseMoveEvent

        If TAB_PEN_MODE = m_intTabMode Then
            fnPenMode_DrawCircle(e.button, e.x, e.y, False)
        End If

    End Sub

    'FvxDipslayEx̃}EX[u
    Private Sub AxFvxDisplayEx1_MouseDownEvent(ByVal sender As System.Object, ByVal e As AxFVXCOMDISPLAYEXLib._IFvxDisplayExEvents_MouseDownEvent) Handles AxFvxDisplayEx1.MouseDownEvent

        If TAB_PEN_MODE = m_intTabMode Then
            fnPenMode_DrawCircle(e.button, e.x, e.y, True)
        End If

    End Sub

    'y[h̕`
    Private Sub fnPenMode_DrawCircle(ByVal Button As Long, ByVal X As Long, ByVal Y As Long, ByVal First As Boolean)

        If 0 = (Button And &H1) Then
            m_pCircle.x = X
            m_pCircle.y = Y
            m_pCircle.radius = trbPenSize.Value
            AxFvxDisplayEx1.UpdateFigure(m_intPenCircleID, m_pCircle)
        Else
            Dim pOldCircle As New FvCircle
            pOldCircle.x = m_pCircle.x
            pOldCircle.y = m_pCircle.y
            pOldCircle.radius = m_pCircle.radius

            m_pCircle.x = X
            m_pCircle.y = Y
            m_pCircle.radius = trbPenSize.Value
            AxFvxDisplayEx1.UpdateFigure(m_intPenCircleID, m_pCircle)

            frmMain.AxFvxPattern1.PaintOnMask(m_pCircle, 1, m_intWriteBit, m_intWriteErase2)
            If First = False Then
                fnDrawCircleToCircle(pOldCircle, m_pCircle)
            End If

            AxFvxDisplayEx1.ClearOverlay(m_intWriteOvrNo)
            AxFvxDisplayEx1.DrawPatternMask(m_intWriteOvrNo, frmMain.AxFvxPattern1.GetOcx(), m_intWriteBit, m_enmWriteColor, ALPHA_VALUE)
        End If

    End Sub

    '~Ɖ~q̕`
    Private Sub fnDrawCircleToCircle(ByRef oldCircle As FvCircle, ByRef newCircle As FvCircle)

        'ړXZo
        Dim dblAngle As Double
        Dim x1 As Integer, y1 As Integer
        Dim x2 As Integer, y2 As Integer
        Dim x3 As Integer, y3 As Integer
        Dim x4 As Integer, y4 As Integer
        Dim pRect As New FvRectangle
        Dim dblPIdev2 As Double

        dblPIdev2 = PI / 2

        dblAngle = fnAtan2(newCircle.y - oldCircle.y, newCircle.x - oldCircle.x)

        x1 = oldCircle.radius * Math.Cos(dblAngle - dblPIdev2) + oldCircle.x
        y1 = oldCircle.radius * Math.Sin(dblAngle - dblPIdev2) + oldCircle.y
        x2 = newCircle.radius * Math.Cos(dblAngle - dblPIdev2) + newCircle.x
        y2 = newCircle.radius * Math.Sin(dblAngle - dblPIdev2) + newCircle.y
        x3 = newCircle.radius * Math.Cos(dblAngle + dblPIdev2) + newCircle.x
        y3 = newCircle.radius * Math.Sin(dblAngle + dblPIdev2) + newCircle.y
        x4 = oldCircle.radius * Math.Cos(dblAngle + dblPIdev2) + oldCircle.x
        y4 = oldCircle.radius * Math.Sin(dblAngle + dblPIdev2) + oldCircle.y

        fn4PointsToRect(x1, y1, x2, y2, x3, y3, x4, y4, dblAngle, pRect)

        ']`̕`
        frmMain.AxFvxPattern1.PaintOnMask(pRect, 1, m_intWriteBit, m_intWriteErase2)

    End Sub

    'Atan2
    Private Function fnAtan2(ByVal Y As Double, ByVal X As Double) As Double

        '߂l̓WAłB

        If X <> 0 Then
            If X > 0 Then
                fnAtan2 = Math.Atan(Y / X)
            Else
                If Y > 0 Then
                    fnAtan2 = Math.Atan(Y / X) + PI
                ElseIf Y < 0 Then
                    fnAtan2 = Math.Atan(Y / X) - PI
                Else
                    fnAtan2 = -PI
                End If
            End If
        Else
            If Y > 0 Then
                fnAtan2 = -PI / 2
            ElseIf Y < 0 Then
                fnAtan2 = PI / 2
            Else
                fnAtan2 = 0
            End If
        End If

    End Function

    '4_`̐
    '  (x1,y1)-(x2,y2)-(x3,y3)-(x4,y4)̏Œ_ł邱ƂO
    Private Sub fn4PointsToRect(ByVal x1 As Integer, ByVal y1 As Integer, _
        ByVal x2 As Integer, ByVal y2 As Integer, ByVal x3 As Integer, ByVal y3 As Integer, _
        ByVal x4 As Integer, ByVal y4 As Integer, ByVal angle As Double, ByRef pRect As FvRectangle)

        Dim dblQ As Double
        Dim dblCosq As Double, dblSinq As Double
        Dim cx As Double, cy As Double

        cx = x1
        cy = y1

        dblQ = fnAtan2(y2 - y1, x2 - x1)
        dblCosq = Math.Cos(-dblQ)
        dblSinq = Math.Sin(-dblQ)

        pRect.xs = dblCosq * (x1 - cx) - dblSinq * (y1 - cy) + cx
        pRect.ys = dblSinq * (x1 - cx) + dblCosq * (y1 - cy) + cy
        pRect.xe = dblCosq * (x3 - cx) - dblSinq * (y3 - cy) + cx
        pRect.ye = dblSinq * (x3 - cx) + dblCosq * (y3 - cy) + cy
        pRect.angle = dblQ * 180 / PI
        pRect.rotation_cent_x = 0
        pRect.rotation_cent_y = 0

    End Sub

    '`4_̐
    Private Sub fnRectTo4Points(ByRef pRect As FvRectangle, _
                            ByRef x1 As Integer, ByRef y1 As Integer, _
                            ByRef x2 As Integer, ByRef y2 As Integer, _
                            ByRef x3 As Integer, ByRef y3 As Integer, _
                            ByRef x4 As Integer, ByRef y4 As Integer)

        x1 = pRect.xs
        y1 = pRect.ys
        x2 = pRect.xe
        y2 = pRect.ys
        x3 = pRect.xe
        y3 = pRect.ye
        x4 = pRect.xs
        y4 = pRect.ye

        If pRect.angle <> 0 Then

            Dim dblSinq As Double, dblCosq As Double
            Dim cx As Double, cy As Double
            Dim dblTemp_x As Double, dblTemp_y As Double
            Dim dblRadQ As Double

            cx = pRect.rotation_cent_x + pRect.xs
            cy = pRect.rotation_cent_y + pRect.ys

            dblRadQ = pRect.angle * PI / 180
            dblSinq = Math.Sin(dblRadQ)
            dblCosq = Math.Cos(dblRadQ)

            ' _̎Zo
            dblTemp_x = dblCosq * (x1 - cx) - dblSinq * (y1 - cy) + cx
            dblTemp_y = dblSinq * (x1 - cx) + dblCosq * (y1 - cy) + cy
            x1 = dblTemp_x
            y1 = dblTemp_y

            ' E_̎Zo
            dblTemp_x = dblCosq * (x2 - cx) - dblSinq * (y2 - cy) + cx
            dblTemp_y = dblSinq * (x2 - cx) + dblCosq * (y2 - cy) + cy
            x2 = dblTemp_x
            y2 = dblTemp_y

            ' E_̎Zo
            dblTemp_x = dblCosq * (x3 - cx) - dblSinq * (y3 - cy) + cx
            dblTemp_y = dblSinq * (x3 - cx) + dblCosq * (y3 - cy) + cy
            x3 = dblTemp_x
            y3 = dblTemp_y

            ' _̎Zo
            dblTemp_x = dblCosq * (x4 - cx) - dblSinq * (y4 - cy) + cx
            dblTemp_y = dblSinq * (x4 - cx) + dblCosq * (y4 - cy) + cy
            x4 = dblTemp_x
            y4 = dblTemp_y
        End If

    End Sub

    '_Ɠ_̋Zo
    Private Function fnLenPointToPoint(ByVal x1 As Integer, ByVal y1 As Integer, ByVal x2 As Integer, ByVal y2 As Integer) As Double

        fnLenPointToPoint = Math.Sqrt((x2 - x1) ^ 2 + (y2 - y1) ^ 2)

    End Function

    '}`[hł̃}EX_uNbN
    Private Sub fnFigMode_DblClick(ByVal Button As Integer, ByVal Shift As Integer, ByVal X As Integer, ByVal Y As Integer, ByVal InOut As Integer)

        Select Case AxFvxDisplayEx1.RoiGetFigureType(m_intRoiDispFigure)
            Case DISPLAYEX_ROI_POINT
                Dim pPoint As New FvPoint
                AxFvxDisplayEx1.RoiGetFigure(m_intRoiDispFigure, pPoint)
                fnFigMode_Paint(pPoint)
            Case DISPLAYEX_ROI_LINESEGMENT
                Dim pLs As New FvLineSegment
                AxFvxDisplayEx1.RoiGetFigure(m_intRoiDispFigure, pLs)
                fnFigMode_Paint(pLs)
            Case DISPLAYEX_ROI_LINE
                Dim pLine As New FvLine
                AxFvxDisplayEx1.RoiGetFigure(m_intRoiDispFigure, pLine)
                fnFigMode_Paint(pLine)
            Case DISPLAYEX_ROI_CIRCLE
                Dim pCircle As New FvCircle
                AxFvxDisplayEx1.RoiGetFigure(m_intRoiDispFigure, pCircle)
                fnFigMode_Paint(pCircle)
            Case DISPLAYEX_ROI_ROT_RECT
                Dim pRect As New FvRectangle
                If m_intRoiDispFigure = m_intRoiRectangle Then
                    AxFvxDisplayEx1.RoiGetFigure(m_intRoiDispFigure, pRect)
                    fnFigMode_Paint(pRect)
                Else
                    Dim pEllipse As New FvEllipse
                    Dim x1 As Integer, y1 As Integer
                    Dim x2 As Integer, y2 As Integer
                    Dim x3 As Integer, y3 As Integer
                    Dim x4 As Integer, y4 As Integer

                    AxFvxDisplayEx1.RoiGetFigure(m_intRoiDispFigure, pRect)
                    fnRectTo4Points(pRect, x1, y1, x2, y2, x3, y3, x4, y4)
                    pEllipse.x = (x1 + x3) / 2
                    pEllipse.y = (y1 + y3) / 2
                    pEllipse.axis_x = fnLenPointToPoint(x1, y1, x2, y2)
                    pEllipse.axis_y = fnLenPointToPoint(x1, y1, x4, y4)
                    pEllipse.angle = pRect.angle
                    fnFigMode_Paint(pEllipse)
                End If
        End Select

    End Sub

    'ROI}EX[u
    Private Sub AxFvxDisplayEx1_RoiMouseMove(ByVal sender As System.Object, ByVal e As AxFVXCOMDISPLAYEXLib._IFvxDisplayExEvents_RoiMouseMoveEvent) Handles AxFvxDisplayEx1.RoiMouseMove

        If m_intRoiDispFigure = m_intRoiEllipse Then
            fnDrawEllipse()
        End If

    End Sub

    'ȉ~[hőȉ~̕`
    Private Sub fnDrawEllipse()

        Dim pEllipse As New FvEllipse
        Dim pRect As New FvRectangle
        Dim x1 As Integer, y1 As Integer
        Dim x2 As Integer, y2 As Integer
        Dim x3 As Integer, y3 As Integer
        Dim x4 As Integer, y4 As Integer

        AxFvxDisplayEx1.RoiGetFigure(m_intRoiDispFigure, pRect)
        fnRectTo4Points(pRect, x1, y1, x2, y2, x3, y3, x4, y4)
        pEllipse.x = (x1 + x3) / 2
        pEllipse.y = (y1 + y3) / 2
        pEllipse.axis_x = fnLenPointToPoint(x1, y1, x2, y2)
        pEllipse.axis_y = fnLenPointToPoint(x1, y1, x4, y4)
        pEllipse.angle = pRect.angle
        Me.AxFvxDisplayEx1.ClearOverlay(3)
        Me.AxFvxDisplayEx1.DrawData(3, pEllipse)

    End Sub

    '}`[hł̃p^`
    Private Sub fnFigMode_Paint(ByRef fig As Object)

        frmMain.AxFvxPattern1.PaintOnMask(fig, m_intWriteScope, m_intWriteBit, m_intWriteErase)
        AxFvxDisplayEx1.ClearOverlay(m_intWriteOvrNo)
        AxFvxDisplayEx1.DrawPatternMask(m_intWriteOvrNo, frmMain.AxFvxPattern1.GetOcx(), m_intWriteBit, m_enmWriteColor, ALPHA_VALUE)

    End Sub

    '}`[hł̐}`I{^NbN
    Private Sub rbtFigure_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rbtFigure5.Click, rbtFigure4.Click, rbtFigure3.Click, rbtFigure2.Click, rbtFigure1.Click, rbtFigure0.Click

        Dim strTemp As String
        Dim intTemp As Integer

        strTemp = VisualBasic.Right(sender.name, 1)
        intTemp = Integer.Parse(strTemp)

        AxFvxDisplayEx1.RoiSetFigureEnable(m_intRoiDispFigure, False)
        AxFvxDisplayEx1.ClearOverlay(3)    'EllipsepC[̃NA

        Select Case intTemp
            Case 0
                AxFvxDisplayEx1.RoiSetFigureEnable(m_intRoiPoint, True)
                m_intRoiDispFigure = m_intRoiPoint
            Case 1
                AxFvxDisplayEx1.RoiSetFigureEnable(m_intRoiLineSegment, True)
                m_intRoiDispFigure = m_intRoiLineSegment
            Case 2
                AxFvxDisplayEx1.RoiSetFigureEnable(m_intRoiLine, True)
                m_intRoiDispFigure = m_intRoiLine
            Case 3
                AxFvxDisplayEx1.RoiSetFigureEnable(m_intRoiCircle, True)
                m_intRoiDispFigure = m_intRoiCircle
            Case 4
                AxFvxDisplayEx1.RoiSetFigureEnable(m_intRoiRectangle, True)
                m_intRoiDispFigure = m_intRoiRectangle
            Case 5
                AxFvxDisplayEx1.RoiSetFigureEnable(m_intRoiEllipse, True)
                m_intRoiDispFigure = m_intRoiEllipse
                fnDrawEllipse()
        End Select

        AxFvxDisplayEx1.RoiChangeActiveFigure(m_intRoiDispFigure)

    End Sub

    '}`[hł̃XR[v{^NbN
    Private Sub rbtScope_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rbtScope2.Click, rbtScope1.Click, rbtScope0.Click

        Dim strTemp As String

        strTemp = VisualBasic.Right(sender.name, 1)
        m_intWriteScope = Integer.Parse(strTemp)

    End Sub

    '}`[hłWrite/Erase{^NbN
    Private Sub rbtWriteErase1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rbtWriteErase1_1.Click, rbtWriteErase1_0.Click

        Dim strTemp As String

        strTemp = VisualBasic.Right(sender.name, 1)
        m_intWriteErase = Integer.Parse(strTemp)

    End Sub

    '}`[hł̑SʃNA{^NbN
    Private Sub btnErase_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnErase.Click

        'wΏBit̂݃NA܂

        Dim pRect As New FvRectangle

        frmMain.AxFvxPattern1.GetPatternArea(pRect)

        'ʒu(0,0)-(XSize-1,YSize-1)ɒ
        pRect.xe = pRect.xe - pRect.xs
        pRect.ye = pRect.ye - pRect.ys
        pRect.xs = 0
        pRect.ys = 0
        frmMain.AxFvxPattern1.PaintOnMask(pRect, 1, m_intWriteBit, 1)
        Redraw()

    End Sub

    'h肱ݑΏBitI(}`[h/y[h)
    Private Sub rbtMask_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles rbtMask1.Click, rbtMask0.Click

        Dim strTemp As String
        Dim intTemp As Integer

        strTemp = VisualBasic.Right(sender.name, 1)
        intTemp = Integer.Parse(strTemp)

        '\̕ύX
        fnExecAndViewLayer(intTemp, chkDualDisp.Checked)

        If 0 = intTemp Then
            m_intWriteBit = &H1
            m_intWriteOvrNo = 1
            m_enmWriteColor = COLOR_RED
        Else
            m_intWriteBit = &H2
            m_intWriteOvrNo = 2
            m_enmWriteColor = COLOR_GREEN
        End If

    End Sub

    '}XNs̈旼\(}`[h/y[h)
    Private Sub chkDualDisp_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles chkDualDisp.Click

        Dim intLayer As Integer

        If False <> rbtMask0.Checked Then
            intLayer = 0
        Else
            intLayer = 1
        End If

        '\̕ύX
        fnExecAndViewLayer(intLayer, chkDualDisp.Checked)

    End Sub

    '\C[̐ݒ(}`[h/y[h)
    Private Sub fnExecAndViewLayer(ByVal intLayer As Integer, ByVal intView As Integer)

        If 0 = intView Then
            If 0 = intLayer Then
                '}XN\p̃I[o[C0\
                AxFvxDisplayEx1.SetOverlayEnable(1, True)
                's̈\p̃I[o[C1\
                AxFvxDisplayEx1.SetOverlayEnable(2, False)
            Else
                '}XN\p̃I[o[C0\
                AxFvxDisplayEx1.SetOverlayEnable(1, False)
                's̈\p̃I[o[C1\
                AxFvxDisplayEx1.SetOverlayEnable(2, True)
            End If
        Else
            '}XN\p̃I[o[C0\
            AxFvxDisplayEx1.SetOverlayEnable(1, True)
            's̈\p̃I[o[C1\
            AxFvxDisplayEx1.SetOverlayEnable(2, True)
        End If

    End Sub

    'ĕ`
    Public Sub Redraw()

        'If TAB_FIGURE_MODE = m_TabMode Then
        AxFvxDisplayEx1.ClearOverlay(m_intWriteOvrNo)
        AxFvxDisplayEx1.DrawPatternMask(m_intWriteOvrNo, frmMain.AxFvxPattern1.GetOcx(), m_intWriteBit, m_enmWriteColor, ALPHA_VALUE)
        'Else
        '   FvxDisplayEx1.ClearOverlay m_WriteOvrNo
        '   FvxDisplayEx1.DrawPatternMask m_WriteOvrNo, frmMain.FvxPattern1.getocx(), m_WriteBit, m_WriteColor, ALPHA_VALUE
        'End If

    End Sub

    '^ũNbN
    Private Sub tabMode_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles tabMode.Click

        m_intTabMode = tabMode.SelectedIndex

        If TAB_FIGURE_MODE = m_intTabMode Then
            '}`[hֈڍs
            AxFvxDisplayEx1.RoiMode = FVXCOMDISPLAYEXLib.DISPLAYEX_ROI_MODE.DISPLAYEX_ROIEnable
            AxFvxDisplayEx1.SetFigureEnable(m_intPenCircleID, False)

            'ȉ~I͑ȉ~̕`s
            If Me.rbtFigure5.Checked = True Then
                fnDrawEllipse()
            End If
        Else
            'y[hֈڍs
            AxFvxDisplayEx1.RoiMode = FVXCOMDISPLAYEXLib.DISPLAYEX_ROI_MODE.DISPLAYEX_ROIDisable
            AxFvxDisplayEx1.SetFigureEnable(m_intPenCircleID, True)

            AxFvxDisplayEx1.ClearOverlay(3)
        End If

    End Sub

    'SʃNA{^NbN
    Private Sub btnErase2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnErase2.Click

        Dim pRect As New FvRectangle

        frmMain.AxFvxPattern1.GetPatternArea(pRect)
        'ʒu(0,0)-(XSize-1,YSize-1)ɒ
        pRect.xe = pRect.xe - pRect.xs
        pRect.ye = pRect.ye - pRect.ys
        pRect.xs = 0
        pRect.ys = 0
        frmMain.AxFvxPattern1.PaintOnMask(pRect, 1, m_intWriteBit, 1)
        Redraw()

    End Sub
End Class